You can use group shape to move shapes but keep their related location, resize & keep size ratio, rotate with same angle etc.
You can group/ungroup multiple shapes using the following code:
window.onload = function () {
var spread = new GC.Spread.Sheets.Workbook(document.getElementById("ss"), {sheetCount: 1});
initSpread(spread);
};
function initSpread(spread) {
var sheet = spread.getSheet(0);
let rectangle = sheet.shapes.add("rectangle", GC.Spread.Sheets.Shapes.AutoShapeType.rectangle, 100, 60, 150, 150);
let rectangleStyle = rectangle.style();
rectangleStyle.fill.color = "#F4F8EB";
rectangleStyle.line.color = "#82bc00";
rectangle.style(rectangleStyle);
let oval = sheet.shapes.add("oval", GC.Spread.Sheets.Shapes.AutoShapeType.oval, 400, 60, 150, 150);
let ovalStyle = oval.style();
ovalStyle.fill.color = "#e3e3e3";
ovalStyle.line.color = "#e3e3e3";
oval.style(ovalStyle);
var cube = sheet.shapes.add("cube", GC.Spread.Sheets.Shapes.AutoShapeType.cube, 100, 240, 150, 150);
var can = sheet.shapes.add("can", GC.Spread.Sheets.Shapes.AutoShapeType.can, 400, 240, 150, 150);
var shapes = [cube, can];
var groupShape = sheet.shapes.group(shapes);
var host = spread.getHost();
host.addEventListener("click", function (e) {
var shapes = sheet.shapes.all(), activeShapes = [];
for (var i = 0; i < shapes.length; i++) {
var shape = shapes[i];
if (shape.isSelected()) {
activeShapes.push(shape);
}
}
if (activeShapes.length === 1 && activeShapes[0] instanceof GC.Spread.Sheets.Shapes.GroupShape) {
_getElementById("ungroup").disabled = false;
_getElementById("group").disabled = true;
} else {
_getElementById("ungroup").disabled = true;
_getElementById("group").disabled = false;
}
}
);
_getElementById("group").addEventListener("click", function () {
var activeShape = sheet.shapes.all().filter(function (sp) {
return sp.isSelected();
});
if (activeShape.length > 1) {
var groupShape = sheet.shapes.group(activeShape);
groupShape.isSelected(true);
_getElementById("ungroup").disabled = false;
_getElementById("group").disabled = true;
}
});
_getElementById("ungroup").addEventListener("click", function () {
var activeShape = sheet.shapes.all().filter(function (sp) {
return sp.isSelected() && sp instanceof GC.Spread.Sheets.Shapes.GroupShape;
});
if (activeShape.length) {
activeShape.forEach(function (shape) {
sheet.shapes.ungroup(shape);
});
_getElementById("ungroup").disabled = true;
_getElementById("group").disabled = false;
}
});
}
function _getElementById(id){
return document.getElementById(id);
}
<!doctype html>
<html style="height:100%;font-size:14px;">
<head>
<meta charset="utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0" />
<link rel="stylesheet" type="text/css" href="$DEMOROOT$/en/purejs/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css">
<script src="$DEMOROOT$/en/purejs/node_modules/@mescius/spread-sheets/dist/gc.spread.sheets.all.min.js" type="text/javascript"></script>
<script src="$DEMOROOT$/en/purejs/node_modules/@mescius/spread-sheets-shapes/dist/gc.spread.sheets.shapes.min.js" type="text/javascript"></script>
<script src="$DEMOROOT$/spread/source/js/license.js" type="text/javascript"></script>
<script src="app.js" type="text/javascript"></script>
<link rel="stylesheet" type="text/css" href="styles.css">
</head>
<body>
<div class="sample-tutorial">
<div id="ss" class="sample-spreadsheets"></div>
<div class="options-container">
<div class="option-row">
Try selecting the shapes in Spread and grouping/ungrouping them to see how the selection area changes.
</div>
<div class="option-row">
*the cube and the cylinder are already grouped.
</div>
<hr />
<div class="option-row">
<label>Group Selected Shapes</label>
<input type="button" id="group" value="Group">
<br/>
<label>Ungroup Selected Shapes</label>
<input type="button" id="ungroup" value="Ungroup">
</div>
</div>
</div></body>
</html>
.sample-tutorial {
position: relative;
height: 100%;
overflow: hidden;
}
.sample-spreadsheets {
width: calc(100% - 280px);
height: 100%;
overflow: hidden;
float: left;
}
.options-container {
float: right;
width: 280px;
padding: 12px;
height: 100%;
box-sizing: border-box;
background: #fbfbfb;
overflow: auto;
}
.option-row {
font-size: 14px;
padding: 5px;
margin-top: 5px;
}
.sample-options {
z-index: 1000;
}
label {
display: block;
margin-bottom: 6px;
}
p{
padding:2px 10px;
background-color:#F4F8EB;
}
input {
padding: 4px 6px;
width: 160px;
}
input[type=button] {
margin-top: 6px;
display: block;
}
body {
position: absolute;
top: 0;
bottom: 0;
left: 0;
right: 0;
}

You can use group shape to move shapes but keep their related location, resize & keep size ratio, rotate with same angle etc.
You can group/ungroup multiple shapes using the following code:
import { Component, NgModule, enableProdMode } from '@angular/core';
import { BrowserModule } from '@angular/platform-browser';
import { platformBrowserDynamic } from '@angular/platform-browser-dynamic';
import { SpreadSheetsModule } from '@mescius/spread-sheets-angular';
import GC from '@mescius/spread-sheets';
import "@mescius/spread-sheets-shapes";
import './styles.css';
@Component({
selector: 'app-component',
templateUrl: 'src/app.component.html'
})
export class AppComponent {
spread: GC.Spread.Sheets.Workbook;
hostStyle = {
width: 'calc(100% - 280px)',
height: '100%',
overflow: 'hidden',
float: 'left'
};
canGroup = true;
group() {
let self = this, spread = self.spread;
let activeSheet = spread.getActiveSheet();
let activeShape = activeSheet.shapes.all().filter(function(sp: GC.Spread.Sheets.Shapes.ShapeBase) {
return sp.isSelected();
});
if (activeShape.length > 1) {
var groupShape = activeSheet.shapes.group(activeShape);
groupShape.isSelected(true);
self.canGroup = false;
}
}
ungroup() {
let self = this, spread = self.spread;
let activeSheet = spread.getActiveSheet();
let activeShape = activeSheet.shapes.all().filter(function(sp: GC.Spread.Sheets.Shapes.ShapeBase) {
return sp.isSelected();
});
if (activeShape.length > 0) {
activeShape.forEach(function(shape: GC.Spread.Sheets.Shapes.ShapeBase) {
activeSheet.shapes.ungroup(shape);
});
self.canGroup = true;
}
}
initSpread($event: any) {
let spread = $event.spread, self = this;
self.spread = spread;
let sheet = spread.getSheet(0);
let rectangle = sheet.shapes.add("rectangle", GC.Spread.Sheets.Shapes.AutoShapeType.rectangle, 100, 60, 150, 150);
let rectangleStyle = rectangle.style();
rectangleStyle.fill.color = "#F4F8EB";
rectangleStyle.line.color = "#82bc00";
rectangle.style(rectangleStyle);
let oval = sheet.shapes.add("oval", GC.Spread.Sheets.Shapes.AutoShapeType.oval, 400, 60, 150, 150);
let ovalStyle = oval.style();
ovalStyle.fill.color = "#e3e3e3";
ovalStyle.line.color = "#e3e3e3";
oval.style(ovalStyle);
let cube = sheet.shapes.add("cube", GC.Spread.Sheets.Shapes.AutoShapeType.cube, 100, 240, 150, 150);
let can = sheet.shapes.add("can", GC.Spread.Sheets.Shapes.AutoShapeType.can, 400, 240, 150, 150);
let shapes = [cube, can];
sheet.shapes.group(shapes);
spread.bind(GC.Spread.Sheets.Events.ShapeSelectionChanged, function() {
let activeSheet = spread.getActiveSheet();
let shapes = activeSheet.shapes.all(), activeShapes = [];
for (let i = 0; i < shapes.length; i++) {
let shape = shapes[i];
if (shape.isSelected()) {
activeShapes.push(shape);
}
}
if (activeShapes.length === 1 && activeShapes[0] instanceof GC.Spread.Sheets.Shapes.GroupShape) {
self.canGroup = false;
} else {
self.canGroup = true;
}
})
}
}
@NgModule({
imports: [BrowserModule, SpreadSheetsModule],
declarations: [AppComponent],
exports: [AppComponent],
bootstrap: [AppComponent]
})
export class AppModule { }
enableProdMode();
// Bootstrap application with hash style navigation and global services.
platformBrowserDynamic().bootstrapModule(AppModule);
<!doctype html>
<html style="height:100%;font-size:14px;">
<head>
<meta charset="utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0" />
<link rel="stylesheet" type="text/css" href="$DEMOROOT$/en/angular/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css">
<!-- Polyfills -->
<script src="$DEMOROOT$/en/angular/node_modules/core-js/client/shim.min.js"></script>
<script src="$DEMOROOT$/en/angular/node_modules/zone.js/fesm2015/zone.min.js"></script>
<!-- SystemJS -->
<script src="$DEMOROOT$/en/angular/node_modules/systemjs/dist/system.js"></script>
<script src="systemjs.config.js"></script>
<script>
// workaround to load 'rxjs/operators' from the rxjs bundle
System.import('rxjs').then(function (m) {
System.import('@angular/compiler');
System.set(SystemJS.resolveSync('rxjs/operators'), System.newModule(m.operators));
System.import('$DEMOROOT$/en/lib/angular/license.ts');
System.import('./src/app.component');
});
</script>
</head>
<body>
<app-component></app-component>
</body>
</html>
<div class="sample-tutorial">
<gc-spread-sheets class="sample-spreadsheets" [hostStyle]="hostStyle" (workbookInitialized)="initSpread($event)">
</gc-spread-sheets>
<div class="options-container">
<div class="option-row">
Try selecting the shapes in Spread and grouping/ungrouping them to see how the selection area changes.
</div>
<div class="option-row">
*the cube and the cylinder are already grouped.
</div>
<hr />
<div class="option-row">
<label>Group Selected Shapes</label>
<input type="button" [disabled]="! canGroup" value="Group" (click)="group()">
<br />
<label>Ungroup Selected Shapes</label>
<input type="button" [disabled]="canGroup" value="Ungroup" (click)="ungroup()">
</div>
</div>
</div>
.sample-tutorial {
position: relative;
width: 100%;
height: 100%;
overflow: hidden;
}
.options-container {
float: right;
width: 280px;
padding: 12px;
height: 100%;
box-sizing: border-box;
background: #fbfbfb;
overflow: auto;
}
.option-row {
font-size: 14px;
padding: 5px;
margin-top: 5px;
}
.sample-options {
z-index: 1000;
}
label {
display: block;
margin-bottom: 6px;
}
p{
padding:2px 10px;
background-color:#F4F8EB;
}
input {
padding: 4px 6px;
width: 160px;
}
input[type=button] {
margin-top: 6px;
display: block;
}
body {
position: absolute;
top: 0;
bottom: 0;
left: 0;
right: 0;
}
(function (global) {
System.config({
transpiler: 'ts',
typescriptOptions: {
tsconfig: true
},
meta: {
'typescript': {
"exports": "ts"
},
'*.css': { loader: 'css' }
},
paths: {
// paths serve as alias
'npm:': 'node_modules/'
},
// map tells the System loader where to look for things
map: {
'core-js': 'npm:core-js/client/shim.min.js',
'zone': 'npm:zone.js/fesm2015/zone.min.js',
'rxjs': 'npm:rxjs/dist/bundles/rxjs.umd.min.js',
'@angular/core': 'npm:@angular/core/fesm2022',
'@angular/common': 'npm:@angular/common/fesm2022/common.mjs',
'@angular/compiler': 'npm:@angular/compiler/fesm2022/compiler.mjs',
'@angular/platform-browser': 'npm:@angular/platform-browser/fesm2022/platform-browser.mjs',
'@angular/platform-browser-dynamic': 'npm:@angular/platform-browser-dynamic/fesm2022/platform-browser-dynamic.mjs',
'@angular/common/http': 'npm:@angular/common/fesm2022/http.mjs',
'@angular/router': 'npm:@angular/router/fesm2022/router.mjs',
'@angular/forms': 'npm:@angular/forms/fesm2022/forms.mjs',
'jszip': 'npm:jszip/dist/jszip.min.js',
'typescript': 'npm:typescript/lib/typescript.js',
'ts': './plugin.js',
'tslib':'npm:tslib/tslib.js',
'css': 'npm:systemjs-plugin-css/css.js',
'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js',
'systemjs-babel-build':'npm:systemjs-plugin-babel/systemjs-babel-browser.js',
'@mescius/spread-sheets': 'npm:@mescius/spread-sheets/index.js',
'@mescius/spread-sheets-shapes': 'npm:@mescius/spread-sheets-shapes/index.js',
'@mescius/spread-sheets-angular': 'npm:@mescius/spread-sheets-angular/fesm2020/mescius-spread-sheets-angular.mjs',
'@grapecity/jsob-test-dependency-package/react-components': 'npm:@grapecity/jsob-test-dependency-package/react-components/index.js'
},
// packages tells the System loader how to load when no filename and/or no extension
packages: {
src: {
defaultExtension: 'ts'
},
rxjs: {
defaultExtension: 'js'
},
"node_modules": {
defaultExtension: 'js'
},
"node_modules/@angular": {
defaultExtension: 'mjs'
},
"@mescius/spread-sheets-angular": {
defaultExtension: 'mjs'
},
'@angular/core': {
defaultExtension: 'mjs',
main: 'core.mjs'
}
}
});
})(this);

You can use group shape to move shapes but keep their related location, resize & keep size ratio, rotate with same angle etc.
You can group/ungroup multiple shapes using the following code:
import * as React from 'react';
import { createRoot } from 'react-dom/client';
import './styles.css';
import { AppFunc } from './app-func';
// import { App } from './app-class';
// 1. Functional Component sample
createRoot(document.getElementById('app')).render(<AppFunc />);
// 2. Class Component sample
// createRoot(document.getElementById('app')).render(<App />);
import * as React from 'react';
import GC from '@mescius/spread-sheets';
import { SpreadSheets } from '@mescius/spread-sheets-react';
import "@mescius/spread-sheets-shapes";
let spread = null;
export function AppFunc() {
const [canGroup, setCanGroup] = React.useState(true);
const group = () => {
let activeSheet = spread.getActiveSheet();
let activeShape = activeSheet.shapes.all().filter(function (sp) {
return sp.isSelected();
});
if (activeShape.length > 1) {
var groupShape = activeSheet.shapes.group(activeShape);
groupShape.isSelected(true);
setCanGroup(false);
}
}
const ungroup = () => {
let activeSheet = spread.getActiveSheet();
let activeShape = activeSheet.shapes.all().filter(function (sp) {
return sp.isSelected();
});
if (activeShape.length > 0) {
activeShape.forEach(function (shape) {
activeSheet.shapes.ungroup(shape);
});
setCanGroup(true);
}
}
const initSpread = (currSpread) => {
spread = currSpread;
let sheet = spread.getSheet(0);
let rectangle = sheet.shapes.add("rectangle", GC.Spread.Sheets.Shapes.AutoShapeType.rectangle, 100, 60, 150, 150);
let rectangleStyle = rectangle.style();
rectangleStyle.fill.color = "#F4F8EB";
rectangleStyle.line.color = "#82bc00";
rectangle.style(rectangleStyle);
let oval = sheet.shapes.add("oval", GC.Spread.Sheets.Shapes.AutoShapeType.oval, 400, 60, 150, 150);
let ovalStyle = oval.style();
ovalStyle.fill.color = "#e3e3e3";
ovalStyle.line.color = "#e3e3e3";
oval.style(ovalStyle);
let cube = sheet.shapes.add("cube", GC.Spread.Sheets.Shapes.AutoShapeType.cube, 100, 240, 150, 150);
let can = sheet.shapes.add("can", GC.Spread.Sheets.Shapes.AutoShapeType.can, 400, 240, 150, 150);
let shapes = [cube, can];
sheet.shapes.group(shapes);
spread.bind(GC.Spread.Sheets.Events.ShapeSelectionChanged, function () {
let activeSheet = spread.getActiveSheet();
let shapes = activeSheet.shapes.all(), activeShapes = [];
for (let i = 0; i < shapes.length; i++) {
let shape = shapes[i];
if (shape.isSelected()) {
activeShapes.push(shape);
}
}
if (activeShapes.length === 1 && activeShapes[0] instanceof GC.Spread.Sheets.Shapes.GroupShape) {
setCanGroup(false);
} else {
setCanGroup(true);
}
});
}
return (<div class="sample-tutorial">
<div class="sample-spreadsheets">
<SpreadSheets workbookInitialized={spread => initSpread(spread)}>
</SpreadSheets>
</div>
<div class="options-container">
<div class="option-row">
Try selecting the shapes in Spread and grouping/ungrouping them to see how the selection area changes.
</div>
<div class="option-row">
*the cube and the cylinder are already grouped.
</div>
<hr />
<div class="option-row">
<label>Group Selected Shapes</label>
<input type="button" disabled={!canGroup} value="Group" onClick={() => { group() }}></input>
<br />
<label>Ungroup Selected Shapes</label>
<input type="button" disabled={canGroup} value="Ungroup" onClick={() => { ungroup() }}></input>
</div>
</div>
</div>);
}
import * as React from 'react';
import GC from '@mescius/spread-sheets';
import { SpreadSheets } from '@mescius/spread-sheets-react';
import "@mescius/spread-sheets-shapes";
const Component = React.Component;
export class App extends Component {
constructor(props) {
super(props);
this.spread = null;
this.state = {
canGroup: true
}
}
render() {
return (<div class="sample-tutorial">
<div class="sample-spreadsheets">
<SpreadSheets workbookInitialized={spread => this.initSpread(spread)}>
</SpreadSheets>
</div>
<div class="options-container">
<div class="option-row">
Try selecting the shapes in Spread and grouping/ungrouping them to see how the selection area changes.
</div>
<div class="option-row">
*the cube and the cylinder are already grouped.
</div>
<hr />
<div class="option-row">
<label>Group Selected Shapes</label>
<input type="button" disabled={!this.state.canGroup} value="Group" onClick={() => { this.group() }}></input>
<br />
<label>Ungroup Selected Shapes</label>
<input type="button" disabled={this.state.canGroup} value="Ungroup" onClick={() => { this.ungroup() }}></input>
</div>
</div>
</div>);
}
group() {
let self = this, spread = self.spread;
let activeSheet = spread.getActiveSheet();
let activeShape = activeSheet.shapes.all().filter(function (sp) {
return sp.isSelected();
});
if (activeShape.length > 1) {
var groupShape = activeSheet.shapes.group(activeShape);
groupShape.isSelected(true);
self.setState({ canGroup: false });
}
}
ungroup() {
let self = this, spread = self.spread;
let activeSheet = spread.getActiveSheet();
let activeShape = activeSheet.shapes.all().filter(function (sp) {
return sp.isSelected();
});
if (activeShape.length > 0) {
activeShape.forEach(function (shape) {
activeSheet.shapes.ungroup(shape);
});
self.setState({ canGroup: true });
}
}
initSpread(spread) {
let self = this;
self.spread = spread;
let sheet = spread.getSheet(0);
let rectangle = sheet.shapes.add("rectangle", GC.Spread.Sheets.Shapes.AutoShapeType.rectangle, 100, 60, 150, 150);
let rectangleStyle = rectangle.style();
rectangleStyle.fill.color = "#F4F8EB";
rectangleStyle.line.color = "#82bc00";
rectangle.style(rectangleStyle);
let oval = sheet.shapes.add("oval", GC.Spread.Sheets.Shapes.AutoShapeType.oval, 400, 60, 150, 150);
let ovalStyle = oval.style();
ovalStyle.fill.color = "#e3e3e3";
ovalStyle.line.color = "#e3e3e3";
oval.style(ovalStyle);
let cube = sheet.shapes.add("cube", GC.Spread.Sheets.Shapes.AutoShapeType.cube, 100, 240, 150, 150);
let can = sheet.shapes.add("can", GC.Spread.Sheets.Shapes.AutoShapeType.can, 400, 240, 150, 150);
let shapes = [cube, can];
sheet.shapes.group(shapes);
spread.bind(GC.Spread.Sheets.Events.ShapeSelectionChanged, function () {
let activeSheet = spread.getActiveSheet();
let shapes = activeSheet.shapes.all(), activeShapes = [];
for (let i = 0; i < shapes.length; i++) {
let shape = shapes[i];
if (shape.isSelected()) {
activeShapes.push(shape);
}
}
if (activeShapes.length === 1 && activeShapes[0] instanceof GC.Spread.Sheets.Shapes.GroupShape) {
self.setState({ canGroup: false });
} else {
self.setState({ canGroup: true });
}
});
}
}
<!doctype html>
<html style="height:100%;font-size:14px;">
<head>
<meta charset="utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0" />
<link rel="stylesheet" type="text/css" href="$DEMOROOT$/en/react/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css">
<!-- SystemJS -->
<script src="$DEMOROOT$/en/react/node_modules/systemjs/dist/system.src.js"></script>
<script src="systemjs.config.js"></script>
<script>
System.import('$DEMOROOT$/en/lib/react/license.js').then(function () {
System.import('./src/app');
});
</script>
</head>
<body>
<div id="app"></div>
</body>
</html>
.sample-tutorial {
position: relative;
height: 100%;
overflow: hidden;
}
.sample-spreadsheets {
width: calc(100% - 280px);
height: 100%;
overflow: hidden;
float: left;
}
.options-container {
float: right;
width: 280px;
padding: 12px;
height: 100%;
box-sizing: border-box;
background: #fbfbfb;
overflow: auto;
}
.option-row {
font-size: 14px;
padding: 5px;
margin-top: 5px;
}
.sample-options {
z-index: 1000;
}
label {
display: block;
margin-bottom: 6px;
}
p{
padding:2px 10px;
background-color:#F4F8EB;
}
input {
padding: 4px 6px;
width: 160px;
}
input[type=button] {
margin-top: 6px;
display: block;
}
body {
position: absolute;
top: 0;
bottom: 0;
left: 0;
right: 0;
}
#app {
height: 100%;
}
(function (global) {
System.config({
transpiler: 'plugin-babel',
babelOptions: {
es2015: true,
react: true
},
meta: {
'*.css': { loader: 'css' }
},
paths: {
// paths serve as alias
'npm:': 'node_modules/'
},
// map tells the System loader where to look for things
map: {
'@mescius/spread-sheets': 'npm:@mescius/spread-sheets/index.js',
'@mescius/spread-sheets-shapes': 'npm:@mescius/spread-sheets-shapes/index.js',
'@mescius/spread-sheets-react': 'npm:@mescius/spread-sheets-react/index.js',
'@grapecity/jsob-test-dependency-package/react-components': 'npm:@grapecity/jsob-test-dependency-package/react-components/index.js',
'react': 'npm:react/cjs/react.production.js',
'react-dom': 'npm:react-dom/cjs/react-dom.production.js',
'react-dom/client': 'npm:react-dom/cjs/react-dom-client.production.js',
'scheduler': 'npm:scheduler/cjs/scheduler.production.js',
'css': 'npm:systemjs-plugin-css/css.js',
'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js',
'systemjs-babel-build':'npm:systemjs-plugin-babel/systemjs-babel-browser.js'
},
// packages tells the System loader how to load when no filename and/or no extension
packages: {
src: {
defaultExtension: 'jsx'
},
"node_modules": {
defaultExtension: 'js'
},
}
});
})(this);

You can use group shape to move shapes but keep their related location, resize & keep size ratio, rotate with same angle etc.
You can group/ungroup multiple shapes using the following code:
<template>
<div class="sample-tutorial">
<gc-spread-sheets class="sample-spreadsheets" @workbookInitialized="initSpread">
</gc-spread-sheets>
<div class="options-container">
<div class="option-row">
Try selecting the shapes in Spread and grouping/ungrouping them to see how the selection area changes.
</div>
<br/>
<div class="option-row">
*the cube and the cylinder are already grouped.
</div>
<hr />
<div class="option-row">
<label>Group Selected Shapes</label>
<input type="button" :disabled="!canGroup" value="Group" @click="group">
<br />
<label>Ungroup Selected Shapes</label>
<input type="button" :disabled="canGroup" value="Ungroup" @click="ungroup">
</div>
</div>
</div>
</template>
<script setup>
import GC from "@mescius/spread-sheets";
import { ref } from 'vue';
import "@mescius/spread-sheets-vue";
import '@mescius/spread-sheets-shapes';
const refSpread = ref(null);
const canGroup = ref(true);
function initSpread(spread) {
refSpread.value = spread;
let sheet = spread.getSheet(0);
let rectangle = sheet.shapes.add("rectangle", GC.Spread.Sheets.Shapes.AutoShapeType.rectangle, 100, 60, 150, 150);
let rectangleStyle = rectangle.style();
rectangleStyle.fill.color = "#F4F8EB";
rectangleStyle.line.color = "#82bc00";
rectangle.style(rectangleStyle);
let oval = sheet.shapes.add("oval", GC.Spread.Sheets.Shapes.AutoShapeType.oval, 400, 60, 150, 150);
let ovalStyle = oval.style();
ovalStyle.fill.color = "#e3e3e3";
ovalStyle.line.color = "#e3e3e3";
oval.style(ovalStyle);
let cube = sheet.shapes.add("cube", GC.Spread.Sheets.Shapes.AutoShapeType.cube, 100, 240, 150, 150);
let can = sheet.shapes.add("can", GC.Spread.Sheets.Shapes.AutoShapeType.can, 400, 240, 150, 150);
let shapes = [cube, can];
sheet.shapes.group(shapes);
spread.bind(GC.Spread.Sheets.Events.ShapeSelectionChanged, function () {
let activeSheet = spread.getActiveSheet();
let shapes = activeSheet.shapes.all(),
activeShapes = [];
for (let i = 0; i < shapes.length; i++) {
let shape = shapes[i];
if (shape.isSelected()) {
activeShapes.push(shape);
}
}
if (activeShapes.length === 1 && activeShapes[0] instanceof GC.Spread.Sheets.Shapes.GroupShape) {
canGroup.value = false;
} else {
canGroup.value = true;
}
});
}
function group() {
let spread = refSpread.value;
let activeSheet = spread.getActiveSheet();
let activeShape = activeSheet.shapes.all().filter(function (sp) {
return sp.isSelected();
});
if (activeShape.length > 1) {
var groupShape = activeSheet.shapes.group(activeShape);
groupShape.isSelected(true);
canGroup.value = false;
}
}
function ungroup() {
let spread = refSpread.value;
let activeSheet = spread.getActiveSheet();
let activeShape = activeSheet.shapes.all().filter(function (sp) {
return sp.isSelected();
});
if (activeShape.length > 0) {
activeShape.forEach(function (shape) {
activeSheet.shapes.ungroup(shape);
});
canGroup.value = true;
}
}
</script>
<style scoped>
.sample-tutorial {
position: relative;
height: 100%;
overflow: hidden;
}
.sample-spreadsheets {
width: calc(100% - 280px);
height: 100%;
overflow: hidden;
float: left;
}
.options-container {
float: right;
width: 280px;
padding: 12px;
height: 100%;
box-sizing: border-box;
background: #fbfbfb;
overflow: auto;
}
.option-row {
font-size: 14px;
padding-left: 5px;
}
.divide-line {
width: 100%;
height: 1px;
background: #cbcbcb;
margin-top: 10px;
margin-bottom: 3px;
}
.title {
text-align: center;
font-weight: bold;
}
label {
display: block;
margin-top: 15px;
margin-bottom: 5px;
}
p {
padding: 2px 10px;
background-color: #F4F8EB;
}
input {
padding: 4px 6px;
width: 160px;
}
input[type=button] {
margin-top: 6px;
display: block;
}
select {
width: 160px;
margin-left: 10px;
display: inline;
}
textarea {
width: 160px;
margin-left: 10px;
}
body {
position: absolute;
top: 0;
bottom: 0;
left: 0;
right: 0;
}
#app {
height: 100%;
}
</style>
<!DOCTYPE html>
<html style="height:100%;font-size:14px;">
<head>
<meta charset="utf-8" />
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<title>SpreadJS VUE</title>
<meta name="viewport" content="width=device-width, initial-scale=1.0" />
<link rel="stylesheet" type="text/css"
href="$DEMOROOT$/en/vue3/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css">
<script src="$DEMOROOT$/spread/source/data/inventory-tracker.js" type="text/javascript"></script>
<script src="$DEMOROOT$/en/vue3/node_modules/systemjs/dist/system.src.js"></script>
<script src="./systemjs.config.js"></script>
<script src="./compiler.js" type="module"></script>
<script>
var System = SystemJS;
System.import("./src/app.js");
System.import('$DEMOROOT$/en/lib/vue3/license.js');
</script>
</head>
<body>
<div id="app"></div>
</body>
</html>
(function (global) {
SystemJS.config({
transpiler: 'plugin-babel',
babelOptions: {
es2015: true
},
paths: {
// paths serve as alias
'npm:': 'node_modules/'
},
packageConfigPaths: [
'./node_modules/*/package.json',
"./node_modules/@mescius/*/package.json",
"./node_modules/@babel/*/package.json",
"./node_modules/@vue/*/package.json"
],
map: {
'vue': "npm:vue/dist/vue.esm-browser.js",
'tiny-emitter': 'npm:tiny-emitter/index.js',
'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js',
"systemjs-babel-build": "npm:systemjs-plugin-babel/systemjs-babel-browser.js",
'@mescius/spread-sheets': 'npm:@mescius/spread-sheets/index.js',
'@mescius/spread-sheets-shapes': 'npm:@mescius/spread-sheets-shapes/index.js',
'@mescius/spread-sheets-vue': 'npm:@mescius/spread-sheets-vue/index.js'
},
meta: {
'*.css': { loader: 'systemjs-plugin-css' },
'*.vue': { loader: "../plugin-vue/index.js" }
}
});
})(this);